<i18n>
  {
    "fr": {
      "title-1": "Le laboratoire",
      "title-2": "Discipline(s) HCERES",
      "title-3": "Les sites",
      "info-1": "Définissez le nom de votre laboratoire et ses tutelles.",
      "info-2": "Définissez la ou les disciplines de recherche de votre laboratoire ainsi que le pourcentage en effectif que cette discipline représente.",
      "info-3": "Définissez le site principal de votre laboratoire ainsi que les autres sites où il est implanté. Un site est un lieu géographique contraint à la France et aux DOM-TOM.",
      "label-1": "Acronyme du laboratoire",
      "label-2": "Tutelle(s), séparée(s) par une virgule",
      "label-3": "Prc.",
      "label-4": "Site principal du laboratoire (ville)",
      "label-5": "Aucune ville trouvée",
      "label-6": "Taille de l'agglomération",
      "label-7": "Quand la ville où se situe votre laboratoire fait partie d’une agglomération urbaine, déclarez celle-ci et non celle de la ville d’implantation. Ex: s'il se situe dans une ville de 30 000 habitants, mais cette ville fait partie d’une métropole de 500 000 habitants, cliquez sur 'plus de 250 000 habitants'.",
      "label-8": "moins de 100 000 habitants",
      "label-9": "entre 100 000 et 250 000 habitants",
      "label-10": "plus de 250 000 habitants",
      "label-11": "Autre(s) site(s), séparée(s) par une virgule",
      "label-12": "Ajouter un site",
      "error-1": "Le pourcentage total des disciplines doit être égal à 100%.",
      "error-2": "Cette position est trop éloignée du site principal de votre laboratoire.",
      "error-3": "Veuillez affiner la position du site principal de votre laboratoire en positionnant le marqueur sur la carte.",
      "error-4": "La discipline",
      "error-5": "n'est pas valide",
      "save-msg": "Les informations de votre laboratoire ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>."
    },
    "en": {
      "title-1": "The laboratory",
      "title-2": "Discipline(s)",
      "title-3": "The sites",
      "info-1": "Define the name of your laboratory and its administrations.",
      "info-2": "Define the research discipline(s) of your laboratory and the percentage of staff that this discipline represents.",
      "info-3": "Define the main site of your laboratory as well as the other sites where it is located. A site is a geographical location limited to France and DOM-TOM.",
      "label-1": "Acronym of the laboratory",
      "label-2": "Administration(s), separated by a comma",
      "label-3": "Prc.",
      "label-4": "Main laboratory site (city)",
      "label-5": "No city found",
      "label-6": "Size of the agglomeration",
      "label-7": "When the city where your laboratory is located is part of an urban agglomeration, declare it and not the city of establishment. Ex: if it is located in a city of 30 000 inhabitants, but this city is part of a metropolis of 500 000 inhabitants, click on 'more than 250 000 inhabitants'.",
      "label-8": "less than 100,000 inhabitants",
      "label-9": "between 100,000 and 250,000 inhabitants",
      "label-10": "more than 250,000 inhabitants",
      "label-11": "Other site(s), separated by a comma",
      "label-12": "Add a site",
      "error-1": "The total percentage of disciplines must equal 100%.",
      "error-2": "This position is too far from the main site of your laboratory.",
      "error-3": "Please refine the location of your main lab site by positioning the marker on the map.",
      "error-4": "The discipline",
      "error-5": "is not valid",
      "save-msg": "Your laboratory data have been <strong><span style='color:green;'>successfully</span></strong>saved."
    }
  }
</i18n>

<template>
  <div>
    <serveur-info :erreur="erreur" />
    <form @submit.prevent="validateBeforeSubmit">
      <div class="columns">
        <div class="column">
          <su-service :icon="'flask'">
            <template #title>
              {{ $t('title-1') }}
            </template>
            {{ $t('info-1') }}
            <br />
            <br />
            <b-field
              :label="$t('label-1') + ' *'"
              :type="{'is-danger': errors.has('laboratory')}"
              :message="errors.first('laboratory')">
              <b-input
                name="laboratory"
                icon="flask"
                @input="inputChanged"
                :placeholder="$t('label-1') + '*'"
                v-model="laboratory.name"
                v-validate="'required'"
                maxlength="50"
              ></b-input>
            </b-field>
            <b-field
              :label="$t('label-2') + ' *'"
              :type="{'is-danger': errors.has('administrations')}"
              :message="errors.first('administrations')"
            >
              <administration-input
                @input="inputChanged"
                v-model="laboratory.administrations"
              />
            </b-field>
          </su-service>
        </div>
        <div class="column">
          <su-service :icon="'hubzilla'">
            <template #title>
              {{ $t('title-2') }}
            </template>
            {{ $t('info-2') }}
            <br />
            <br />
            <div class="columns">
              <div class="column is-7">
                <b-field
                  :label="$t('title-2') + ' *'"
                />
              </div>
              <div class="column is-2">
                <b-field
                  :label="$t('label-3') + ' *'"
                />
              </div>
              <div class="column is-3">
              </div>
            </div>
            <div
              class="columns"
              v-for="(discipline,index) in laboratory.disciplines"
              :key="index"
            >
            <div class="column is-7">
                <discipline-input
                  @input="disciplineChanged"
                  v-model="laboratory.disciplines[index]"/>
              </div>
              <div class="column is-3">
                <b-input
                  name="percentage"
                  @input="inputChanged"
                  v-model="discipline.percentage"
                  v-validate="'required|numeric'"
                  icon="percent"
                ></b-input>
              </div>
              <div class="column is-1">
                <b-button
                  icon-left="minus"
                  @click="removeDiscipline(index)"
                >
                </b-button>
              </div>
            </div>
            <div class="columns">
              <div class="column is-7">
                <discipline-input
                  @input="disciplineChanged"
                  v-model="cdiscipline"
                />
              </div>
              <div class="column is-3">
                <b-input
                  name="percentage"
                  @input="inputChanged"
                  v-model="cdiscipline.percentage"
                  v-validate="'required|numeric'"
                  icon="percent"
                />
              </div>
              <div class="column is-1">
                <b-button
                  v-show="totalDiscPerc<100"
                  icon-left="plus"
                  @click="addDiscipline"
                />
              </div>
            </div>
            <p class="help is-danger"
              v-if="totalDiscError"
            >
            {{ $t('error-1') }}
            </p>
            <p class="help is-danger"
              v-if="discError"
            >
              {{ discError }}
            </p>
          </su-service>
        </div>
      </div>
      <br />
      <div class="columns">
        <div class="column">
          <su-service :icon="'map-marker'">
          <template #title>
            {{ $t('title-3') }}
          </template>
          {{ $t('info-3') }}
          <br />
          <br />
          <geonames-input
            :label="$t('label-4')"
            :value="laboratory.mainSite"
            :countryCode="laboratory.country"
            @select="updateMarker"
            @input="inputChanged"
            :allowedCountries="geonamesAllowedCountries"
          />
          <b-field
            :type="{'is-danger': errors.has('citySize')}"
            :message="errors.first('citySize')"
          >
            <template slot="label">
              {{ $t('label-6') }} *
              <b-tooltip
                multilined
                :label="$t('label-7')"
                type="is-dark">
                <b-icon icon="info-circle" />
              </b-tooltip>
            </template>
            <b-select
              name="citySize"
              @input="inputChanged"
              v-model="laboratory.citySize"
              v-validate="'required'"
              :placeholder="$t('label-4') + '*'"
              expanded
            >
              <option value="0">{{ $t('label-8') }}</option>
              <option value="1">{{ $t('label-9') }}</option>
              <option value="2">{{ $t('label-10') }}</option>
            </b-select>
          </b-field>
          <br />
          <b-field
            :label="$t('label-11')"
          >
            <b-taginput
              v-model="laboratory.sites"
              ellipsis
              @input="inputChanged"
              icon="caret-right"
              :placeholder="$t('label-12')"
            />
          </b-field>
          </su-service>
        </div>
        <div class="column">
          <l-map
            @click="changeMarker"
            ref="labLeaflet"
            :zoom="zoom"
            :center="center"
            style="z-index: 0;"
            :style="[errorMarker ? { border:'1px solid #ff3880' } : { border:'1px solid #4280b0' } ]"
          >
            <l-tilelayer url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"></l-tilelayer>
            <l-marker
              :draggable="true"
              @drag="changeMarker"
              :lat-lng="currentMarker"
            >
            </l-marker>
          </l-map>
          <div v-if="errorAreaMarker" style="margin-top:8px;color:#ff3860;font-size:.75rem">
            {{ $t('error-2') }}
          </div>
          <div v-else-if="errorMarker" style="margin-top:8px;color:#ff3860;font-size:.75rem">
            {{ $t('error-3') }}
          </div>
        </div>
      </div>
      <br />
      <nav class="level">
        <div class="level-left"></div>
        <div class="buttons level-right">
          <b-button
            class="button"
            @click="resetForm()"
            :disabled="resetDisabled"
            icon-left="close"
          >
          {{ $t('cancel') }}
          </b-button>
          <button
            type="submit"
            :disabled="saveDisabled"
            class="level-item button is-primary"
          >
            <span class="icon is-small"><i class="sui sui-save"></i></span>
            <span>{{ $t('save') }}</span>
          </button>
        </div>
      </nav>
    </form>
  </div>
</template>

<script>
import { geonames } from '@/mixins/geonames'
import '@/plugins/leaflet.js'

const DEFAULT_LATITUDE = 46.75
const DEFAULT_LONGITUDE = 2.32
const VALID_MARKER_AREA = 0.08

export default {
  name: 'MyLaboratory',
  components: {
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'l-map': () => import('vue2-leaflet').then(({ LMap }) => LMap),
    'l-tilelayer': () => import('vue2-leaflet').then(({ LTileLayer }) => LTileLayer),
    'l-marker': () => import('vue2-leaflet').then(({ LMarker }) => LMarker),
    'su-service': () => import('@/components/SUService.vue'),
    'administration-input': () => import('@/components/AdministrationInput.vue'),
    'discipline-input': () => import('@/components/DisciplineInput.vue'),
    'geonames-input': () => import('@/components/GeonamesInput.vue')
  },
  mixins: [geonames],
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      zoom: 5,
      errorAreaMarker: false,
      errorMarker: false,
      siteLatitude: DEFAULT_LATITUDE,
      siteLongitude: DEFAULT_LONGITUDE,
      geonamesAllowedCountries: ['MF', 'BL', 'PF', 'YT', 'GF', 'PM', 'RE', 'GP', 'MQ', 'WF', 'TF', 'NC', 'FR'],
      autoIsSelected: false,
      isFetching: false,
      discError: '',
      isDiscError: true,
      totalDiscError: false,
      cdiscipline: {
        id: null,
        percentage: 100,
        name: ''
      },
      laboratory: {
        id: null,
        name: '',
        mainSite: '',
        country: '',
        area: '',
        administrations: [],
        citySize: null,
        latitude: DEFAULT_LATITUDE,
        longitude: DEFAULT_LONGITUDE,
        disciplines: [],
        sites: []
      },
      erreur: '',
      savedLaboratory: {
        id: null,
        name: '',
        mainSite: '',
        country: '',
        area: '',
        administrations: [],
        citySize: null,
        latitude: DEFAULT_LATITUDE,
        longitude: DEFAULT_LONGITUDE,
        disciplines: [],
        sites: []
      },
      hasChanged: false,
      hasBeenSavedOnce: false,
      changedBug: 0
    }
  },
  computed: {
    totalDiscPerc: function () {
      let percTotal = 0
      for (let disc of this.laboratory.disciplines) {
        percTotal += parseInt(disc.percentage)
      }
      if (!isNaN(parseInt(this.cdiscipline.percentage))) {
        percTotal += parseInt(this.cdiscipline.percentage)
      }
      return percTotal
    },
    currentMarker: function () {
      return [this.laboratory.latitude, this.laboratory.longitude]
    },
    center: function () {
      return [this.laboratory.latitude, this.laboratory.longitude]
    },
    resetDisabled: function () {
      let toReturn = true
      if (this.hasBeenSavedOnce || this.laboratory.id !== null) {
        toReturn = !this.hasChanged
      } else {
        toReturn = true
      }
      return toReturn
    },
    saveDisabled: function () {
      let toReturn = true
      if (this.hasBeenSavedOnce || this.laboratory.id !== null) {
        if (!this.totalDiscError && !this.isDiscError && this.laboratory.administrations.length > 0) {
          toReturn = !this.hasChanged
        } else {
          toReturn = true
        }
      } else {
        toReturn = !(this.laboratory.name && this.laboratory.mainSite && this.laboratory.administrations.length > 0 && !this.isDiscError && !this.totalDiscError && this.laboratory.citySize)
      }
      return toReturn
    }
  },
  methods: {
    changeMarker (event) {
      if (this.siteLatitude !== DEFAULT_LATITUDE && this.siteLongitude !== DEFAULT_LONGITUDE) {
        if (event.latlng['lat'] < parseFloat(this.siteLatitude) + parseFloat(VALID_MARKER_AREA) && event.latlng['lat'] > parseFloat(this.siteLatitude) - parseFloat(VALID_MARKER_AREA)) {
          if (event.latlng['lng'] < parseFloat(this.siteLongitude) + parseFloat(VALID_MARKER_AREA) && event.latlng['lng'] > parseFloat(this.siteLongitude) - parseFloat(VALID_MARKER_AREA)) {
            this.laboratory.latitude = event.latlng['lat']
            this.laboratory.longitude = event.latlng['lng']
            this.errorMarker = false
            this.errorAreaMarker = false
            this.hasChanged = true
          } else {
            this.errorMarker = true
            this.errorAreaMarker = true
            this.hasChanged = false
          }
        } else {
          this.errorMarker = true
          this.errorAreaMarker = true
          this.hasChanged = false
        }
      }
    },
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.laboratory.latitude === this.siteLatitude && this.laboratory.longitude === this.siteLongitude) {
            this.errorMarker = true
          } else {
            this.errorMarker = false
            const loadingComponent = this.$buefy.loading.open({
              container: null
            })
            let allDisciplines = JSON.parse(JSON.stringify(this.laboratory.disciplines))
            allDisciplines.push({
              'id': this.cdiscipline.id,
              'name': this.cdiscipline.name,
              'percentage': parseInt(this.cdiscipline.percentage)
            })
            this.$store.dispatch('api/saveLaboratory', {
              id: this.laboratory.id,
              name: this.laboratory.name,
              administrations: this.laboratory.administrations,
              disciplines: allDisciplines,
              mainSite: this.laboratory.mainSite,
              country: this.laboratory.country,
              area: this.laboratory.area,
              citySize: this.laboratory.citySize,
              latitude: this.laboratory.latitude,
              longitude: this.laboratory.longitude,
              sites: this.laboratory.sites
            })
              .then(data => {
                loadingComponent.close()
                this.laboratory = JSON.parse(JSON.stringify(data))
                this.siteLatitude = this.laboratory.latitude + 0.000000001
                this.siteLongitude = this.laboratory.longitude + 0.000000001
                let ld = this.laboratory.disciplines.pop()
                this.cdiscipline.id = ld.id
                this.cdiscipline.name = ld.name
                this.cdiscipline.percentage = ld.percentage
                this.savedLaboratory = JSON.parse(JSON.stringify(data))
                this.erreur = ''
                this.hasChanged = false
                this.hasBeenSavedOnce = true
                window.scrollTo(0, 0)
                this.$buefy.toast.open({
                  type: 'is-light',
                  message: this.$t('save-msg')
                })
              })
              .catch((erreur) => {
                loadingComponent.close()
                this.erreur = erreur.response.data
                this.laboratory = this.savedLaboratory
              })
          }
        }
      })
    },
    addDiscipline () {
      if (this.totalDiscPerc <= 100) {
        this.laboratory.disciplines.push({
          'id': this.cdiscipline.id,
          'name': this.cdiscipline.name,
          'percentage': parseInt(this.cdiscipline.percentage)
        })
        this.cdiscipline.id = null
        this.cdiscipline.name = ''
        this.cdiscipline.percentage = 100 - this.totalDiscPerc + parseInt(this.cdiscipline.percentage)
        this.inputChanged()
      }
    },
    removeDiscipline (index) {
      this.laboratory.disciplines.splice(index, 1)
      this.cdiscipline.percentage = 100 - this.totalDiscPerc + parseInt(this.cdiscipline.percentage)
      this.inputChanged()
    },
    resetForm () {
      this.laboratory = JSON.parse(JSON.stringify(this.savedLaboratory))
      let ld = this.laboratory.disciplines.pop()
      this.cdiscipline.id = ld.id
      this.cdiscipline.name = ld.name
      this.cdiscipline.percentage = ld.percentage
      this.hasChanged = false
      this.erreur = ''
    },
    inputChanged () {
      // to prevent 2 @input
      if (this.changedBug === 2) {
        this.hasChanged = true
      } else {
        this.changedBug += 1
      }
    },
    disciplineChanged () {
      this.inputChanged()
      this.discError = ''
      this.isDiscError = false
      for (let disc of this.laboratory.disciplines) {
        if (disc.id === null) {
          this.discError = this.$t('error-4') + ' « ' + disc.name + ' » ' + this.$t('error-5') + '.'
          this.isDiscError = true
        }
      }
      if (this.cdiscipline.id === null) {
        this.discError = this.$t('error-4') + ' « ' + this.cdiscipline.name + ' » ' + this.$t('error-5') + '.'
        this.isDiscError = true
      }
    },
    resetVille () {
      if (!this.autoIsSelected) {
        this.laboratory.mainSite = ''
      }
    },
    updateMarker (option) {
      if (option) {
        this.laboratory.latitude = parseFloat(option.lat)
        this.laboratory.longitude = parseFloat(option.lng)
        this.siteLatitude = parseFloat(option.lat)
        this.siteLongitude = parseFloat(option.lng)
        this.laboratory.country = option.countryCode
        this.laboratory.area = option.adminCode1
        this.laboratory.mainSite = option.name
        this.autoIsSelected = true
        this.inputChanged()
      }
    }
  },
  watch: {
    totalDiscPerc: function () {
      if (this.totalDiscPerc !== 100) {
        this.totalDiscError = true
      } else {
        this.totalDiscError = false
      }
    },
    '$i18n.locale': function () {
      this.disciplineChanged()
    }
  },
  mounted () {
    const loadingComponent = this.$buefy.loading.open({
      container: null
    })
    this.$store.dispatch('api/getLaboratory')
      .then(data => {
        loadingComponent.close()
        if (data) {
          this.savedLaboratory = JSON.parse(JSON.stringify(data))
          this.laboratory = JSON.parse(JSON.stringify(data))
          this.siteLatitude = this.laboratory.latitude + 0.000000001
          this.siteLongitude = this.laboratory.longitude + 0.000000001
          let ld = this.laboratory.disciplines.pop()
          this.cdiscipline.id = ld.id
          this.cdiscipline.name = ld.name
          this.cdiscipline.percentage = ld.percentage
          this.isDiscError = false
        }
      })
      .catch((erreur) => {
        loadingComponent.close()
      })
    this.hasChanged = false
  }
}
</script>
